> ## Documentation Index
> Fetch the complete documentation index at: https://docs.domino.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Register model



## OpenAPI

````yaml /api-specs/6.3/public-api.json put /model-monitor/v2/api/model
openapi: 3.0.3
info:
  title: Domino Public API
  description: Reference for Domino's public REST API endpoints.
  version: 6.3.1
  x-catalog-key: nucleus
servers:
  - url: https://mycluster.domino.tech
    description: >-
      Replace 'mycluster.domino.tech' with your Domino cluster hostname. For
      Domino Cloud customers, that is `your-subdomain`.domino.tech (e.g.,
      acme.domino.tech). For self-hosted deployments, it is the hostname you
      reach the Domino UI at.
security: []
tags:
  - name: Projects
  - name: Project templates
  - name: Workspaces
  - name: Jobs
  - name: HPC Jobs
  - name: Environments
  - name: Hardware Tiers
  - name: Datasets
  - name: Data Sources
  - name: AI Gateway
  - name: GenAI
  - name: AI Systems
  - name: Apps
  - name: App versions
  - name: App instances
  - name: Model APIs
  - name: Registered models
  - name: Model deployment
  - name: Extensions
  - name: Cost and billing
  - name: Users and organizations
  - name: Service accounts
  - name: Personal Access Tokens
  - name: Personal Access Tokens (admin)
  - name: Audit Trail
  - name: Custom metrics
  - name: PPM
  - name: Model Monitoring models
  - name: Model Monitoring drift and quality
  - name: Model Monitoring settings
  - name: Model Monitoring authentication
  - name: Governance bundles
  - name: Governance policies
  - name: Governance evidence and results
  - name: Governance operations
  - name: NetApp Volumes
  - name: NetApp Volumes snapshots
  - name: NetApp Volumes filesystems
  - name: NetApp Volumes transfers
  - name: Tags
  - name: Properties
externalDocs:
  description: OpenAPI
  url: https://swagger.io/resources/open-api/
paths:
  /model-monitor/v2/api/model:
    summary: Model Operations.
    put:
      tags:
        - Model Monitoring models
      operationId: registerModelThroughConfig
      requestBody:
        required: true
        description: ''
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/dmm-plier_modelRegistrationConfigRequest'
      responses:
        '200':
          description: Successfully registered the Model.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/dmm-plier_modelResponse'
        '400':
          description: Bad request input data.
        '403':
          description: Forbidden. The endpoint enforces permissions.
        '405':
          description: Method not allowed.
        '500':
          description: Internal server error, check server logs.
      security:
        - dmm-plier_DominoApiKeyAuth: []
        - dmm-plier_DmmApiKeyAuth: []
        - dmm-plier_cookieAuth: []
        - dmm-plier_BearerAuth: []
components:
  schemas:
    dmm-plier_modelRegistrationConfigRequest:
      title: Model Registration Config
      description: Config to be used to register a model with DMM.
      allOf:
        - $ref: '#/components/schemas/dmm-plier_datasetRegistrationConfigRequest'
        - type: object
          required:
            - modelMetadata
          properties:
            modelMetadata:
              $ref: '#/components/schemas/dmm-plier_model'
    dmm-plier_modelResponse:
      allOf:
        - $ref: '#/components/schemas/dmm-plier_modelResponseCommon'
        - type: object
          properties:
            permissions:
              $ref: '#/components/schemas/dmm-plier_modelPermissions'
    dmm-plier_datasetRegistrationConfigRequest:
      title: Model Registration Config
      description: Config to be used to register a model with DMM.
      type: object
      required:
        - datasetDetails
      properties:
        variables:
          type: array
          items:
            $ref: '#/components/schemas/dmm-plier_variableConfigRegistrationRequest'
        datasetDetails:
          $ref: '#/components/schemas/dmm-plier_datasetConfigRegistrationRequest'
        run_cohort_analysis:
          type: boolean
    dmm-plier_model:
      title: Model Config
      description: Model Config to be used to register a model with DMM.
      type: object
      required:
        - name
        - modelType
        - version
      properties:
        name:
          description: Name of the Model.
          type: string
        modelType:
          description: Type of the Model.
          type: string
          enum:
            - classification
            - regression
        version:
          description: Version of the Model.
          type: string
        description:
          description: Description for the Model.
          type: string
        author:
          description: Author of the Model.
          type: string
        dateCreated:
          description: The creation date of the model.
          type: integer
          nullable: true
        sourceType:
          $ref: '#/components/schemas/dmm-plier_sourceType'
        sourceDetails:
          $ref: '#/components/schemas/dmm-plier_workbenchModelDetails'
    dmm-plier_modelResponseCommon:
      allOf:
        - $ref: '#/components/schemas/dmm-plier_model'
        - type: object
          required:
            - id
            - createdAt
            - updatedAt
            - userId
            - ingestionStatus
            - registrationStatus
            - isDeleted
          properties:
            id:
              description: Model Identifier.
              type: string
            createdAt:
              description: Creation timestamp of the Model.
              type: integer
            updatedAt:
              description: Last update timestamp for the Model.
              type: integer
            userId:
              description: Id of the model owner, who created the model.
              type: string
            ownerUsername:
              description: username of the model owner, who created the model.
              type: string
            ownerEmail:
              description: email of the model owner, who created the model.
              type: string
            ownerName:
              description: name of the model owner, who created the model.
              type: string
            tags:
              description: List of tags associated with the model
              type: array
              items:
                $ref: '#/components/schemas/dmm-plier_modelTag'
            ingestionStatus:
              description: Dataset Ingestion status for a model.
              type: string
              enum:
                - created
                - training
                - prediction
                - ground_truth
            registrationStatus:
              description: Registration status of a model.
              type: string
              enum:
                - draft
                - created
                - deleted
            isDeleted:
              description: Whether the model is deleted or not.
              type: boolean
            visibility:
              $ref: '#/components/schemas/dmm-plier_visibility'
            collaborators:
              type: array
              items:
                $ref: '#/components/schemas/dmm-plier_collaborator'
    dmm-plier_modelPermissions:
      title: Model Permissions
      description: Permission metadata required for a model response
      type: object
      required:
        - canRegisterDataset
        - canUpdateMonitoringSettings
        - canEditPermissions
      properties:
        canRegisterDataset:
          description: Whether the requesting user can register a dataset for the model
          type: boolean
        canUpdateMonitoringSettings:
          description: >-
            Whether the requesting user can update monitoring settings for the
            model
          type: boolean
        canEditPermissions:
          description: Whether the requesting user can edit permissions for the model
          type: boolean
    dmm-plier_variableConfigRegistrationRequest:
      title: Variable Config Registration
      description: Variable config to configure a variable of a model.
      type: object
      required:
        - name
        - valueType
        - variableType
      properties:
        name:
          description: Name of the variable.
          type: string
        valueType:
          $ref: '#/components/schemas/dmm-plier_valueType'
        variableType:
          $ref: '#/components/schemas/dmm-plier_variableType'
        binsCategories:
          description: Bin categories to be used for a categorical typed variable.
          type: array
          items:
            type: string
        binsEdges:
          description: Bin Edges to be used for a numerical typed variable.
          type: array
          items:
            type: number
        binsNum:
          $ref: '#/components/schemas/dmm-plier_binCount'
        binsEstimatorMethod:
          $ref: '#/components/schemas/dmm-plier_binsEstimatorMethod'
        featureImportance:
          description: Feature Importance for a feature variable.
          type: number
        precomputedBinCounts:
          description: Precomputed counts for bins.
          type: array
          items:
            type: integer
        predictionProbabilityLabels:
          description: Labels for the prediction probabilities.
          type: array
          items:
            type: string
        forPredictionOutput:
          description: Corresponding prediction variable name, for the given variable.
          type: string
    dmm-plier_datasetConfigRegistrationRequest:
      title: Dataset Config Registration
      description: Config for the dataset to be registered with the model.
      type: object
      required:
        - name
        - datasetType
        - datasetConfig
        - datasourceName
        - datasourceType
      properties:
        name:
          description: Name of the dataset.
          type: string
        datasetType:
          description: Type of the dataset.
          type: string
          enum:
            - file
        datasetConfig:
          $ref: '#/components/schemas/dmm-plier_datasetConfig'
        datasourceName:
          description: Name of the datasource to which the dataset belongs.
          type: string
        datasourceType:
          $ref: '#/components/schemas/dmm-plier_datasourceType'
        featureSetId:
          description: The version id for the current feature set version.
          type: string
        featureSetVersionId:
          description: >-
            The feature set id of the feature set to which the current feature
            set version belongs to.
          type: string
    dmm-plier_sourceType:
      description: Source for the model registration.
      type: string
      enum:
        - domino_workbench
        - standalone
    dmm-plier_workbenchModelDetails:
      title: Domino Workbench model's details.
      description: Model details associated with a Domino workbench model.
      type: object
      required:
        - workbenchModelId
        - workbenchModelVersionId
      properties:
        workbenchModelId:
          description: Workbench's Model id
          type: string
        workbenchModelVersionId:
          description: Workbench Model's version id to be monitored in DMM
          type: string
    dmm-plier_modelTag:
      title: Model Tag
      description: Tag for a model
      required:
        - id
        - tagName
      properties:
        id:
          type: string
        tagName:
          description: name of tag
          type: string
    dmm-plier_visibility:
      description: Model visibility
      type: string
      enum:
        - public
        - private
    dmm-plier_collaborator:
      description: Collaborator for a standalone model
      type: object
      required:
        - userId
        - collaboratorLevel
      properties:
        userId:
          description: user id of the collaborator
          type: string
        collaboratorLevel:
          $ref: '#/components/schemas/dmm-plier_collaboratorLevel'
    dmm-plier_valueType:
      description: Type of data the variable has.
      type: string
      enum:
        - categorical
        - numerical
        - string
        - datetime
    dmm-plier_variableType:
      description: Variable type.
      type: string
      enum:
        - feature
        - prediction
        - row_identifier
        - timestamp
        - ground_truth
        - sample_weight
        - prediction_probability
    dmm-plier_binCount:
      description: Number of bins to be determined (for training datasets)
      type: integer
    dmm-plier_binsEstimatorMethod:
      description: Estimator method to be used to determine the number of bins.
      type: string
      enum:
        - auto
        - doane
        - fd
        - rice
        - scott
        - sqrt
        - sturges
    dmm-plier_datasetConfig:
      type: object
      description: Config for the dataset.
      required:
        - path
        - fileFormat
      properties:
        path:
          description: Path to the dataset in the datasource.
          type: string
        fileFormat:
          $ref: '#/components/schemas/dmm-plier_fileFormat'
    dmm-plier_datasourceType:
      description: Type of the datasource to which the dataset belongs.
      type: string
      enum:
        - s3
        - generic_s3
        - azure_blob
        - azure_data_lake_gen_2
        - google_cloud_storage
        - azure_data_lake_gen_1
        - hdfs
        - nfs
        - snowflake
    dmm-plier_collaboratorLevel:
      description: type of collaborator
      type: string
      enum:
        - editor
        - viewer
    dmm-plier_fileFormat:
      description: Format of the file.
      type: string
      enum:
        - csv
        - parquet
        - snowflake
  securitySchemes:
    dmm-plier_DominoApiKeyAuth:
      type: apiKey
      in: header
      name: X-Domino-Api-Key
    dmm-plier_DmmApiKeyAuth:
      type: apiKey
      in: header
      name: X-DMM-API-KEY
    dmm-plier_cookieAuth:
      type: apiKey
      in: cookie
      name: PLAY_SESSION
    dmm-plier_BearerAuth:
      type: http
      scheme: bearer

````

## Related topics

- [Register models](/6.3/platform-capabilities/features/models/register-and-govern/index.md)
- [Register a Model](/6.3/platform-capabilities/features/monitoring/4-set-up-model-monitor/3-register-a-model.md)
- [Manage models with model registry](/6.3/platform-capabilities/features/models/register-and-govern/model-registry.md)
- [Host an LLM](/6.3/platform-capabilities/features/llms/host-an-llm.md)
